org.cpsolver.studentsct.heuristics.selection

## Class CriticalCoursesBranchAndBoundSelection

- java.lang.Object
- - org.cpsolver.studentsct.heuristics.selection.BranchBoundSelection
  - - org.cpsolver.studentsct.heuristics.selection.CriticalCoursesBranchAndBoundSelection

- All Implemented Interfaces:
    NeighbourSelection<Request,Enrollment>, InfoProvider<Request,Enrollment>, SolverListener<Request,Enrollment>

      public class CriticalCoursesBranchAndBoundSelection
      extends BranchBoundSelection

  This selection is very much like `BranchBoundSelection`, but only critical course requests are assigned (see `Request.isCritical()`. Students that do not have any unassigned critical courses are skipped.
  Parameters:

  Related Solver Parameters
  Parameter | Type | Comment
  --- | --- | ---
  Neighbour.CriticalCoursesBranchAndBoundTimeout | `Integer` | Timeout for each neighbour selection (in milliseconds).
  Neighbour.BranchAndBoundMinimizePenalty | `Boolean` | If true, section penalties (instead of section values) are minimized: overall penalty is minimized together with the maximization of the number of assigned requests and minimization of distance conflicts -- this variant is to better mimic the case when students can choose their sections (section times).

  Version:
    StudentSct 1.3 (Student Sectioning)
    Copyright (C) 2007 - 2014 Tomáš Müller
    muller@unitime.org
    http://muller.unitime.org
    This library is free software; you can redistribute it and/or modify it under the terms of the GNU Lesser General Public License as published by the Free Software Foundation; either version 3 of the License, or (at your option) any later version.
    This library is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details.
    You should have received a copy of the GNU Lesser General Public License along with this library; if not see http://www.gnu.org/licenses/.
  Author:
    Tomáš Müller

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `class` | `CriticalCoursesBranchAndBoundSelection.CriticalCoursesSelection`

    - ### Nested classes/interfaces inherited from class org.cpsolver.studentsct.heuristics.selection.BranchBoundSelection

      `BranchBoundSelection.BranchBoundNeighbour, BranchBoundSelection.Selection`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected boolean` | `iMPP`

    - ### Fields inherited from class org.cpsolver.studentsct.heuristics.selection.BranchBoundSelection

      `iBranchWhenSelectedHasNoConflict, iDistanceConflict, iDistConfWeight, iFilter, iMinimizePenalty, iModel, iNbrIterations, iNbrNoSolution, iNbrStudents, iNbrTimeoutReached, iOrder, iStudentQuality, iStudents, iTimeout, iTimeOverlaps, iTimesToAvoidHeuristics, iTotalTime, sDebug`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `CriticalCoursesBranchAndBoundSelection(DataProperties properties)`
    `CriticalCoursesBranchAndBoundSelection(DataProperties properties, Request.RequestPriority priority)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `BranchBoundSelection.Selection` | `getSelection(Assignment<Request,Enrollment> assignment, Student student)` Branch & bound selection for a student
    `void` | `init(Solver<Request,Enrollment> solver)` Criterion initialization
    `Neighbour<Request,Enrollment>` | `selectNeighbour(Solution<Request,Enrollment> solution)` Select neighbour.

    - ### Methods inherited from class org.cpsolver.studentsct.heuristics.selection.BranchBoundSelection

      `addStudent, getFilter, getInfo, getInfo, init, neighbourFailed, neighbourSelected, nextStudent, setModel, valueSelected, variableSelected, withFilter`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### iMPP

          protected boolean iMPP

  - ### Constructor Detail

    - #### CriticalCoursesBranchAndBoundSelection

          public CriticalCoursesBranchAndBoundSelection(DataProperties properties,
                                                        Request.RequestPriority priority)

    - #### CriticalCoursesBranchAndBoundSelection

          public CriticalCoursesBranchAndBoundSelection(DataProperties properties)

  - ### Method Detail

    - #### init

          public void init(Solver<Request,Enrollment> solver)

      Description copied from interface: `NeighbourSelection`
      Criterion initialization
      Specified by:
        `init` in interface `NeighbourSelection<Request,Enrollment>`
      Overrides:
        `init` in class `BranchBoundSelection`
      Parameters:
        `solver` - current solver

    - #### selectNeighbour

          public Neighbour<Request,Enrollment> selectNeighbour(Solution<Request,Enrollment> solution)

      Description copied from class: `BranchBoundSelection`
      Select neighbour. All students are taken, one by one in a random order. For each student a branch & bound search is employed.
      Specified by:
        `selectNeighbour` in interface `NeighbourSelection<Request,Enrollment>`
      Overrides:
        `selectNeighbour` in class `BranchBoundSelection`
      Parameters:
        `solution` - given solution
      Returns:
        a neighbour assignment

    - #### getSelection

          public BranchBoundSelection.Selection getSelection(Assignment<Request,Enrollment> assignment,
                                                             Student student)

      Description copied from class: `BranchBoundSelection`
      Branch & bound selection for a student
      Overrides:
        `getSelection` in class `BranchBoundSelection`
      Parameters:
        `assignment` - current assignment
        `student` - selected student
      Returns:
        selection